<template>
  <div
    id="emojiContainer"
    class="w-full max-w-[220px] max-h-[496px] rounded-[4px] py-2 h-full flex flex-col overflow-y-auto bg-surface cardShadow"
  >
    <v-list
      color="primary"
      density="compact"
      class="!py-0"
    >
      <v-list-item
        v-for="(item, index) in items"
        :key="item.name"
        :active="false"
        :value="item.name"
        :data-emoji-name="item.name"
        @click="selectItem(index)"
      >
        <div class="w-full flex gap-3 whitespace-nowrap">
          <template v-if="item.fallbackImage">
            <img :src="item.fallbackImage" class="w-5 h-5" alt="emoji" />
          </template>
  
          <template v-else>
            <svn-pro-text bodyLarge regular>
              {{ item.emoji }}
            </svn-pro-text>
          </template>
  
          <svn-pro-text bodyLarge regular class="truncate text-ellipsis">
            :{{ item.name }}:
          </svn-pro-text>
        </div>
      </v-list-item>
    </v-list>
  </div>
</template>

<script setup>
import { ref, onMounted, onUnmounted } from 'vue';
import SvnProText from '../../styles/SvnProText.vue';

onMounted(() => {
  selectedIndex.value = 0;
  window.addEventListener("keydown", onKeyDown);
});

onUnmounted(() => {
  window.removeEventListener("keydown", onKeyDown);
});

const props = defineProps({
  items: { type: Array, default: () => [] },
  command: { type: Function, default: () => { return null } },
});

const selectedIndex = ref(0);

const selectItem = (index) => {
  const item = props.items[index];
  if (item) {
    props.command({ name: item.name });
  }
};

const onKeyDown = (event) => {
  // Arrow Up press
  if (event.key === 'ArrowUp') {
    event.preventDefault();
    const newIndex = (selectedIndex.value + props.items.length - 1) % props.items.length;
    selectedIndex.value = newIndex;

    scrollIntoView(newIndex);

    return true;
  }

  // Arrow Down press
  if (event.key === 'ArrowDown') {
    event.preventDefault();
    const newIndex = (selectedIndex.value + 1) % props.items.length;
    selectedIndex.value = newIndex;

    scrollIntoView(newIndex);

    return true;
  }

  // Enter Press (Execute action)
  if (event.key === 'Enter') {
    selectItem(selectedIndex.value);

    return true;
  }
  
  return false;
};

const scrollIntoView = (index) => {
  const item = props.items[index];
  if (item) {
    const node = document.querySelector(`[data-emoji-name="${item.name}"]`);
    if (node) {
      node.scrollIntoView({ block: 'nearest', behavior: 'smooth' });
    }
  }
};
</script>

<style scoped>
/* total width */
::-webkit-scrollbar {
  background-color: #FBF9F9;
  width: 12px;
}

/* background of the scrollbar except button or resizer */
::-webkit-scrollbar-track {
  background-color: #FBF9F9;
}

/* scrollbar itself */
::-webkit-scrollbar-thumb {
  background-color: #babac0;
  border-radius: 16px;
  border: 4px solid #FBF9F9;
}

/* set button(top and bottom of the scrollbar) */
::-webkit-scrollbar-button {
  display:none;
}

.cardShadow {
  box-shadow: 0px 2px 2px 0px rgba(0, 0, 0, 0.14), 0px 3px 1px 0px rgba(0, 0, 0, 0.12), 0px 1px 5px 0px rgba(0, 0, 0, 0.20);
}
</style>